# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Summary:	A FileHandle that supports ungetting of multiple bytes
Name:		perl-FileHandle-Unget
Version:	0.1634
Release:	21.%{__distinit}%{__distvers}
License:	GPL-2.0-only
URL:		https://metacpan.org/release/FileHandle-Unget
Source0:	https://cpan.metacpan.org/modules/by-module/FileHandle/FileHandle-Unget-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(base)
BuildRequires:	perl(Carp)
BuildRequires:	perl(Cwd)
BuildRequires:	perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:	perl(ExtUtils::Manifest)
BuildRequires:	perl(Fcntl)
BuildRequires:	perl(File::Find)
BuildRequires:	perl(File::Path)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(FindBin)
BuildRequires:	perl(lib)
BuildRequires:	perl(warnings)
# Module Runtime
BuildRequires:	perl(bytes)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(FileHandle)
BuildRequires:	perl(Scalar::Util) >= 1.14
BuildRequires:	perl(strict)
BuildRequires:	perl(Symbol)
BuildRequires:	perl(vars)
# Test Suite
BuildRequires:	perl(Config)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(File::Slurper)
BuildRequires:	perl(File::Spec::Functions)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(Test::Compile)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(UNIVERSAL::require)
# Optional Tests
BuildRequires:	perl(Devel::Leak)
BuildRequires:	perl(Test::Pod)
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Provides:	perl(FileHandle::Unget) = %{version}

%description
FileHandle::Unget is a drop-in replacement for FileHandle that allows more
than one byte to be placed back on the input. It supports an ungetc(ORD), which
can be called more than once in a row, and an ungets(SCALAR), which places a
string of bytes back on the input.

%prep
%setup -q -n FileHandle-Unget-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENSE
%doc CHANGES README TODO
%{perl_vendorlib}/FileHandle/
%{_mandir}/man3/FileHandle::Unget.3*

%changelog
* Wed Jul  9 2025 Paul Howarth <paul@city-fan.org> - 0.1634-21
- Use %%{make_build} and %%{make_install}

* Fri Apr 21 2023 Paul Howarth <paul@city-fan.org> - 0.1634-16
- Use SPDX-format license tag
- Drop support for building with rpm < 4.9
- Use %%license unconditionally

* Sat Jun 27 2020 Paul Howarth <paul@city-fan.org> - 0.1634-7
- Perl 5.32 rebuild

* Wed Jun  5 2019 Paul Howarth <paul@city-fan.org> - 0.1634-4
- Perl 5.30 rebuild

* Thu Jul 12 2018 Paul Howarth <paul@city-fan.org> - 0.1634-1
- Update to 0.1634
  - Fix Makefile.PL warning
  - Fix deleting of inc during release process
  - Better fix for AutomatedTester warning

* Mon Jul  9 2018 Paul Howarth <paul@city-fan.org> - 0.1633-1
- Update to 0.1633
  - Check in standard tests, including one that skips the compile check on
    Windows
  - Add missing URI::Escape dependency
  - Switch from File::Slurp to File::Slurper

* Tue Jul  3 2018 Paul Howarth <paul@city-fan.org> - 0.1629-1
- Update to 0.1629
  - Add standard tests
  - Fix compatibility issue with newer versions of perl, which remove "." from
    @INC (CPAN RT#121434)
- Switch upstream from search.cpan.org to metacpan.org
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Sun Jun 11 2017 Paul Howarth <paul@city-fan.org> - 0.1628-10
- Fix building on Perl without '.' in @INC
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Sun Jul 31 2016 Paul Howarth <paul@city-fan.org> - 0.1628-7
- Fix FTBFS when perl is not in the minimal buildroot
- BR: perl-generators where available
- Simplify find command using -delete

* Wed Jan 27 2016 Paul Howarth <paul@city-fan.org> - 0.1628-4
- Prefer %%global over %%define

* Mon Jun 22 2015 Paul Howarth <paul@city-fan.org> - 0.1628-3
- Perl 5.22 rebuild

* Sun May  3 2015 Paul Howarth <paul@city-fan.org> - 0.1628-1
- Update to 0.1628
  - Prevent CPAN from indexing private-lib

* Mon Apr 20 2015 Paul Howarth <paul@city-fan.org> - 0.1627-1
- Update to 0.1627
  - Clarify licensing terms
  - Move verbose testing to a private module, and implement it in a way that
    doesn't require editing the Makefile after it is generated
  - Require File::Slurp instead of including it, to avoid potential problems
    like this:
    http://www.cpantesters.org/cpan/report/86a0145a-e52b-11e4-a1d1-8536eb4f9f07
  - Fix tests so that they don't prematurely delete the temp file, e.g.:
    http://www.cpantesters.org/cpan/report/3adcb600-6bf9-1014-8336-f8616735162a
  - Fix tests on Windows:
    http://www.cpantesters.org/cpan/report/482c4765-af8d-1014-8ca5-91062b825c07

* Mon Apr 13 2015 Paul Howarth <paul@city-fan.org> - 0.1626-1
- Update to 0.1626
  - Enable verbose testing for CPAN-testers
  - Consolidate issue tracking at rt.cpan.org
  - Use File::Temp for temporary files in the test suite
- License changed to GPLv2

* Sun Apr  5 2015 Paul Howarth <paul@city-fan.org> - 0.1625-1
- Update to 0.1625
  - Modify the memory leak test to check for ≤ 0 bytes; I'm not sure how this
    scenario happens, but test failures like this indicate that it can:
    http://www.cpantesters.org/cpan/report/bdd0e36c-d0dd-11e4-954f-5702e0bfc7aa
  - Attempt to fix loss of lines when $/ is undef
    http://www.cpantesters.org/cpan/report/60452d60-d3cc-11e4-b60b-c2157e3e1735

* Mon Mar 23 2015 Paul Howarth <paul@city-fan.org> - 0.1624-1
- Update to 0.1624
  - Moved code to github
  - Added POD test
  - Improve testability of binmode_bug.t, stdin_tell_bug.t
  - Implement a potential fix for test failures where FileHandle::getline()
    seems to be reading a single line even though $/ is undef
  - Use "local $/" instead of reassigning global $/
  - Improve documentation for input_record_separator()
- Classify buildreqs by usage

* Thu Aug 28 2014 Paul Howarth <paul@city-fan.org> - 0.1623-17
- Use %%license where possible
- Drop %%defattr, redundant since rpm 4.4

* Fri Jun 22 2012 Paul Howarth <paul@city-fan.org> - 0.1623-11
- BR: perl(Cwd), perl(Data::Dumper), perl(Exporter), perl(File::Spec) and
  perl(File::Spec::Functions)
- Don't need to remove empty directories from the buildroot

* Mon Jun 27 2011 Paul Howarth <paul@city-fan.org> - 0.1623-5
- Rebuild for perl 5.14.1 in Rawhide
- Use DESTDIR rather than PERL_INSTALL_ROOT
- Tweak provides filter to work with rpm ≥ 4.9
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Thu Jun 24 2010 Paul Howarth <paul@city-fan.org> - 0.1623-4
- Rebuild for perl 5.12.1 in Rawhide

* Thu May 27 2010 Paul Howarth <paul@city-fan.org> - 0.1623-3
- Fix dist tag for RHEL-6 Beta

* Thu Feb 18 2010 Paul Howarth <paul@city-fan.org> - 0.1623-2
- Fix versioned provide for perl(FileHandle::Unget)
- Add buildreq perl(Devel::Leak) for additional test coverage
- Dist tag for Rawhide no longer needs special-casing
- Use %%{_fixperms} macro instead of our own %%{__chmod} incantation

* Tue Sep  1 2009 Paul Howarth <paul@city-fan.org> - 0.1623-1
- Update to 0.1623
  - Fix uninitialized value warning and incorrect behaviour (CPAN RT#48528)
  - Remove reference to obsolete ExtUtils::MakeMaker::bytes (CPAN RT#48984)

* Thu Jul 17 2008 Paul Howarth <paul@city-fan.org> - 0.1622-1
- Update to 0.1622
- BuildRequire perl(Test::More)
- Tweak dist tag macros to work on current Rawhide with three-part releasenum
- Unget.pm permissions no longer need fixing

* Mon Mar 10 2008 Paul Howarth <paul@city-fan.org> - 0.1621-6
- Clarify license as GPL (unspecified version)

* Sat Mar 17 2007 Paul Howarth <paul@city-fan.org> - 0.1621-3
- Fix dist tag for development releases, CentOS, and Fedora 7 onwards
- Remove buildroot unconditionally in %%clean and %%install
- Remove %%{__perl_version} macro, used only once
- Remove %%{__perl_package} macro, used only twice
- Don't use macros in command paths, hardcode them instead
- Fix argument order for find with -depth
- Use search.cpan.org URLs
- Define %%{__id_u} in a more portable way
- Add buildreq perl(ExtUtils::MakeMaker)

* Wed Jul 13 2005 Paul Howarth <paul@city-fan.org> - 0.1621-2
- Fix bogus Group: tag
- Fix directory ownership issues
- Fix file permissions issues
- Remove optimization settings from %%build, not needed for noarch package

* Wed May 18 2005 Paul Howarth <paul@city-fan.org> - 0.1621-1
- Update to 0.1621; incompatible with Red Hat Enterprise Linux < 4,
  Fedora Core < 3 due to Scalar::Util dependency - the Scalar::Util module
  is shipped with Red Hat perl packages, so we can't just provide an
  updated module package
- Add Scalar::Util ≥ 1.14 dependency
- Remove WeakRef dependency

* Tue May 17 2005 Paul Howarth <paul@city-fan.org> - 0.14-5
- Rewrite spec file in (mainly) Fedora Extras style
- Include full URL for source
- Fix URL
- Use MODULE_COMPAT dependency style and remove explicit perl dependency
- Remove MANIFEST from %%doc

* Thu Dec 23 2004 Paul Howarth <paul@city-fan.org> - 0.14-4
- Tidy up spec file

* Thu Apr 15 2004 Paul Howarth <paul@city-fan.org> - 0.14-3
- Added explicit perl dependency to ensure that an RPM built on a
  system with an updated version of perl (and hence having files
  installed in a place that a non-updated system won't find them)
  will not install on the non-updated system. In such cases, just
  rebuild from the source RPM.
- Changed distribution-identifying macros for greater portability.

* Mon Feb 16 2004 Paul Howarth <paul@city-fan.org> - 0.14-2
- Unified spec file for Red Hat and Fedora Core

* Tue Feb 10 2004 Paul Howarth <paul@city-fan.org> - 0.14-1.fc1
- Update to 0.14, requires perl-WeakRef

* Fri Dec 12 2003 Paul Howarth <paul@city-fan.org> - 0.11-1.fc1
- Used more macros, added current Fedora Core version to RPM release ID

* Tue Nov 25 2003 Paul Howarth <paul@city-fan.org> - 0.11-1
- Initial build
